com.amazonaws.codegen.protocol

## Interface ProtocolMetadataProvider

All Known Implementing Classes:
  AwsCborProtocolMetadataProvider, AwsJsonProtocolMetadataProvider, BaseJsonProtocolMetadataProvider, BaseProtocolMetadataProvider, BaseXmlProtocolMetadataProvider, Ec2ProtocolMetdataProvider, IonProtocolMetadataProvider, QueryProtocolMetadataProvider, RestJsonProtocolMetdataProvider, RestXmlProtocolMetadataProvider

    public interface ProtocolMetadataProvider

Provides various pieces of information that are specific to certain protocols.

### Method Summary

All Methods Instance Methods Abstract Methods
`String` `getBaseExceptionFqcn()`
`String` `getContentType()`
`String` `getExceptionUnmarshallerImpl()`
`String` `getRequestBaseFqcn()`
`String` `getUnmarshallerClassSuffix()`
`String` `getUnmarshallerContextClassName()`
`boolean` `isCborProtocol()`
`boolean` `isIonProtocol()`
`boolean` `isJsonProtocol()`
`boolean` `isXmlProtocol()`

### Method Detail

#### isJsonProtocol

    boolean isJsonProtocol()

Returns:
  True if protocol uses some form of JSON wire format. False otherwise.

#### isXmlProtocol

    boolean isXmlProtocol()

Returns:
  True if protocol uses XML as the wire format. False otherwise.

#### isCborProtocol

    boolean isCborProtocol()

Returns:
  True if protocol uses CBOR as the wire format. False otherwise.

#### isIonProtocol

    boolean isIonProtocol()

Returns:
  True if protocol uses Ion as the wire format. False otherwise.

#### getContentType

    String getContentType()

Returns:
  The content type to use when sending requests. Currently only respected by JSON protocols.

#### getUnmarshallerContextClassName

    String getUnmarshallerContextClassName()

Returns:
  The name of the Unmarshaller Context class used by the generated unmarshaller classes.

#### getUnmarshallerClassSuffix

    String getUnmarshallerClassSuffix()

Returns:
  The suffix for generated unmarshaller classes. I.e. FooStaxUnmarshaller or FooJsonUnmarshaller.

#### getExceptionUnmarshallerImpl

    String getExceptionUnmarshallerImpl()

Returns:
  The default implementation of exception unmarshallers to use or derive from. Currently only used by XML protocols.

#### getBaseExceptionFqcn

    String getBaseExceptionFqcn()

Returns:
  The fully qualified class name of the exception class that all service exceptions will be inherited from. Not to be confused with the service specific base exception which would extend from this base exception.

#### getRequestBaseFqcn

    String getRequestBaseFqcn()

Returns:
  The fully qualified class name of the base request class.